%  ,  
clear; clc;

%%  

%   (   )     
%   ,  PRICES_EUR   
% <Date> - <Hour> - <Value>
load PRICES_EUR PRICES_EUR;
TimeSeries = PRICES_EUR;

%   
P = datenum('15.04.2011 00:00:00', 'dd.mm.yyyy hh:MM:ss');  %   (Origin)
L = 24;                                                     %   (Forecast horizon)

%      
M = 144;
Step = 24;

%%   EMMSP

% 1)     (HistNew)
Index = find(TimeSeries(:,1) == datenum(year(P), month(P), day(P)) & TimeSeries(:,2) == hour(P));
if length(Index) > 1
    fprintf(['  :   P      1  \n']);
else
    HistNewData = TimeSeries([Index-M+1:Index],:);      %     (     P)
    Index = Index - Step * 2;
end

% 2)     Likeness      Step
k = 1;
while Index > 3 * M + 2 * L
    HistOldData = TimeSeries([Index-M+1 : Index],:);
    Likeness(k,1)= Index;
    CheckOld = find(HistOldData(:,3) > 0);                    %   ,   
    CheckNew = find(HistNewData(:,3) > 0);
    if isempty(CheckOld) || isempty(CheckNew)                   
        Likeness(k,2) = 0;
    else
        Likeness(k,2) = abs(corr(HistOldData(:,3), HistNewData(:,3), 'type', 'Pearson'));
    end
    k = k + 1;
    Index = Index - Step;       %       Step
end

% 3)   
MaxLikeness = max(abs(Likeness(:,2)));
IndexLikeness = find(Likeness(:,2) == MaxLikeness);
Index = Likeness(IndexLikeness(1),1);

% 4)     (HistOld)
HistOldData = TimeSeries([Index-M+1 : Index],:);
HistOldData(:,4) = weekday(HistOldData(:,1));
    
% 5)    (BaseHist)
HistBaseData = TimeSeries([Index+1:Index+L],:);
HistBaseData(:,4) = weekday(HistBaseData(:,1));
        
% 6)   HistNew   HistOld   
%  (       ). 
%      ,   
%  . 
X = HistOldData(:,3);
X(:,length(X(1,:))+1) = 1;      %      I
Y = HistNewData(:,3);
E = X(:,2);
Xn = X'* X;
Yn = X'* Y;
invX = inv(Xn);
A = invX * Yn;                  %    A (,     3.4)
Ym = X * A;

% 7) 
X = HistBaseData(:,3);
X(:,length(X(1,:))+1) = 1;
Forecast = X * A;               % ,  

%%   

% 1)   
Index = find(TimeSeries(:,1) == datenum(year(P), month(P), day(P)) & TimeSeries(:,2) == hour(P));
Fact = TimeSeries([Index : Index+L-1],3);

% 2)   MAE (http://www.mbureau.ru/blog/osnovnye-ocenki-tochnosti-prognozirovaniya-vremennyh-ryadov#MAE) 
MAE = mean(abs(Forecast - Fact));
% 3)   MAPE (http://www.mbureau.ru/blog/osnovnye-ocenki-tochnosti-prognozirovaniya-vremennyh-ryadov#MAPE)
MAPE = mean(abs(Forecast - Fact)./Fact);

fprintf([' :\n', '  P = ',datestr(P,'dd.mm.yyyy HH:MM'),'\n', '  L = ', num2str(L),'\n', '  MAE = ',num2str(MAE),' RUB/MWh, MAPE = ',num2str(MAPE*100),'%% \n']);
